#include <stdlib.h>
#include <string.h>
#include "library.h"
#include "cgi.h"
#include "utils.h"
#include "hash.h"
#include "vector.h"
#include "rope.h"
#include "log.h"

vector_t	*datafile_read(rope_t *filestr, vector_t *matchvec,
				char *search);
void		*template_new(void *pathstr);
void		 template_parse(rope_t *tpt, vector_t *results);

void
invoke (void)
{
	hash_t		*cgihash;
	vector_t	*fieldvec;
	vector_t	*results;
	rope_t		*tptstr;
	rope_t		*datastr;
	char		*temp;
	char		*host;
	char		*search;

	cgihash = cgi_hash_new();

	host = getenv(ENV_HOSTNAME);
	if (!host) {
		log("cgisys", PRI_CRIT, "No '" ENV_HOSTNAME "' in "
						"environment");
		exit(0);
	}
	host[strcspn(host, "/")] = 0;

/* Template file */
	tptstr = rope_new(DIR_DATA);
	rope_add(tptstr, host);
	rope_add(tptstr, "/datafile/templates/");
	temp = hash_get(cgihash, "TemplateTitle");
	if (!temp) {
		log("cgiconf", PRI_CRIT, "No 'TemplateTitle' parameter in "
						"cgi hash table");
		exit(0);
	}
	temp[strcspn(temp, "/")] = 0;
	rope_add(tptstr, temp);
	rope_add(tptstr, ".tpt");

/* Data file */
	datastr = rope_new(DIR_DATA);
	rope_add(datastr, host);
	rope_add(datastr, "/datafile/DataFiles/");
	temp = hash_get(cgihash, "DataFileTitle");
	if (!temp) {
		log("cgiconf", PRI_CRIT, "No 'DataFileTitle' parameter in "
						"cgi hash table");
		exit(0);
	}
	temp[strcspn(temp, "/")] = 0;
	rope_add(datastr, temp);
	rope_add(datastr, ".db");

/* Match fields */
	temp = hash_get(cgihash, "Match");
	if (!temp) {
		log("cgiconf", PRI_CRIT, "No 'Match' parameter in "
						"cgi hash table");
		exit(0);
	}
	fieldvec = explode(temp, " ");

/* Search text */
	search = hash_get(cgihash, "Text");
	if (!search) {
		log("cgiconf", PRI_CRIT, "No 'Text' parameter in "
						"cgi hash table");
		exit(0);
	}
	search = lower_case(search); /* Modifies hash table by reference */

/* Results */
	results = datafile_read(datastr, fieldvec, search);

	template_parse(tptstr, results);
}
