/*
 * C utility library
 * Copyright (C) 1999 Open World Ltd
 * Written by Shevek <shevek@anarres.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "library.h"
#include "vector.h"
#include "smalloc.h"
#include "cgi.h"
#include "log.h"

vector_t *
dirvec_new(char *path)
{
	DIR				*dir;
	struct dirent	*dirent;
	vector_t		*v;

	dir = opendir(path);
	if (!dir) {
		log("cgiconf", PRI_CRIT, "Could not opendir() '%s': %s",
						path, strerror(errno));
		return NULL;
	}

	v = vector_new(free, 0);

	while ((dirent = readdir(dir)) != NULL) {
		if (!dirent->d_reclen) continue;    /* Blank filenames */
		if (*dirent->d_name == '.') continue;	/* Dotfile */
		vector_push_back(v, sstrdup(dirent->d_name));
	}

	closedir(dir);

	return v;
}
